from turtle import *
from time import *

"""
The program (modules and variables) that searches out the nodal paths is imported.
This allows us to access the list of all possible paths
"""
from Program_SimpleNodalSearch import *


def walkTheWalk(hamList) :
    #def main():


    # initialise the network each time ... just for the hell of it
    dotTurtle = Turtle()
    dotTurtle.shape("blank")
    dotTurtle.hideturtle()
    dotTurtle.home()
    dotTurtle.penup()

    for nodeNum in range(len(nodalCoords)) :
        if nodeNum == 5 : dotTurtle.penup()
        dotTurtle.setpos(nodalCoords[nodeNum])#head to first node location
        dotTurtle.pendown()
        dotTurtle.dot(20,"blue")
        dotTurtle.write(str(nodeNum +1),"center",font=("Arial",16,"bold"))
        dotTurtle.penup()
        dotTurtle.setpos(nodalCoords[nodeNum])
        #dotTurtle.backward(20)
        dotTurtle.pendown()

    dotTurtle.penup()

    dotTurtle.setpos(nodalCoords[1])#node2
    dotTurtle.pendown()
    dotTurtle.setpos(nodalCoords[4])#node5
    dotTurtle.penup()

    dotTurtle.setpos(nodalCoords[2])#node3
    dotTurtle.pendown()
    dotTurtle.setpos(nodalCoords[4])#node5
    dotTurtle.penup()
    
    dotTurtle.setpos(nodalCoords[3])#node4
    dotTurtle.pendown()
    dotTurtle.setpos(nodalCoords[5])#node6
    dotTurtle.penup()

    dotTurtle.showturtle()
    

    #nodeTurtle.home()
    nodeTurtle.penup()


    for index in hamList :
        #print("index ", index)
        nodeTurtle.setpos(nodalCoords[index-1])
        nodeTurtle.pendown()
        nodeTurtle.stamp()




# assign the coords to each node (imported from SimpleNodalSearch)
networkList =[node1, node2, node3, node4, node5, node6]
nodalCoords = []
for i in range(len(networkList)) :
    nodalCoords.append(networkList[i]["coords"])
print("nodalCoords ", nodalCoords)


mainscreen = Screen()
mainscreen.bgcolor("red")

beginNodalTrip()
print("list of paths ", listOfPaths)
for turtlePath in listOfPaths :
    strTurtlePath = str(turtlePath)
    banville = Turtle()
    banville.penup()
    banville.shape("blank")
    banville.setpos(-200,-200)
    banville.write(strTurtlePath,font=("Arial",16,"bold"))
    banville.sety(-230)
    strTurtlePath = "a short path (not Hamiltonian)"
    if len(turtlePath) == len(networkList) :
        strTurtlePath = "Hamiltonian Walk - 1 visit for each node"
    banville.write(strTurtlePath,font=("Arial",16,"bold"))

    
    nodeTurtle = Turtle()
    nodeTurtle.shape("turtle")
    nodeTurtle.color("green")
    nodeTurtle.pensize(10)
    nodeTurtle.speed(1)
    nodeTurtle.setx(10)
    walkTheWalk(turtlePath)
    mainscreen.textinput("NEXT PATH " + strTurtlePath,"click to see the path")

    sleep(1)
    mainscreen.clearscreen()
    mainscreen.bgcolor("red")
    mainscreen.mode("standard")
    mainscreen.setup(800, 800)
    #nodeTurtle.home()




#if __name__ == "__main__":
#    main()
#    mainscreen.mainloop()
